package geniusweb.events;

public abstract class AbstractEvent implements NegotiationEvent {

	private final Long time;

	@Override
	public Long getTime() {
		return time;
	}

	public AbstractEvent() {
		this.time = System.currentTimeMillis();
	}

	/**
	 * @param now the current time to use. see {@link System#currentTimeMillis()}.
	 */
	public AbstractEvent(Long now) {
		if (now == null || now < 0) {
			throw new IllegalArgumentException("time must be non-null and positive");
		}
		this.time = now;
	}

	@Override
	public String toString() {
		return this.getClass().getSimpleName() + "[" + time + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((time == null) ? 0 : time.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		AbstractEvent other = (AbstractEvent) obj;
		if (time == null) {
			if (other.time != null)
				return false;
		} else if (!time.equals(other.time))
			return false;
		return true;
	}

}
